# Revision 1.1 2007/04/21 19:50:00 iisaka
# initial release

import sys
from scatter.app import *
import scatter.node
import scatter.shell

class Application(scatter.app.Application):
    def __init__(self, argv=sys.argv):
	self.execcmd = "/usr/local/bin/trsh"

        self.default_option += [
	    Option("-f", "--nodefilepath", action="store", type="string",
		    dest="nodefilepath",
		    help="Set file path to the nodefile"),
	    Option("-F", "--nodefile", action="store", type="string",
		    dest="nodefile",
		    help="Search NODEFILE in $HOME/.ScatterCmd or /usr/local/share/ScatterCmd"),
	    Option("-H", "--hostlist", action="store", type="string",
		    dest="hostlist",
		    help="Only execute sepecified node"),
	    Option("-A", "--addhost", action="store", type="string",
		    dest="addhost",
		    help="Add more nodes"),
	    Option("", "--ignore", action="store", type="string",
		    dest="ignore_nodes",
		    help="Set ignore nodes"),
	    Option("", "--REignore", action="store", type="string",
		    dest="ignore_pattern",
		    help="Set ignore nodes via regular expression"),
            Option("-U","--uniq",action="store_true",
                    dest="do_uniq",
                    default=False,
                    help="Discard all but one successive identical host"),
	    Option("", "--list", action="store_true",
		    dest="do_list", default=False,
		    help="list nodefile and exit"),
	    Option("", "--listnodes", action="store_true",
		    dest="do_listnodes", default=False,
		    help="list nodes and exit"),
	    ]

        scatter.app.Application.__init__(self, argv)

	self.execcmd = self.options.execcmd
        nodefile = self.options.nodefilepath
        if self.options.nodefile != None:
            nodefile = self.options.nodefile

        self.nodes = scatter.node.Nodes(nodefile)

        if self.options.do_list:
            self.nodes.list_nodefile()
            sys.exit(0)

        if self.options.do_debug:
            print 'nodefile: ', self.nodes.nodefilepath
            print 'ignore_nodes: ', self.options.ignore_nodes
            print 'ignore_pattern: ', self.options.ignore_pattern
            print 'addhost: ', self.options.addhost
            print 'hostlist: ', self.options.hostlist

        self.nodes.set_ignore_nodes(self.options.ignore_nodes)
        self.nodes.set_ignore_pattern(self.options.ignore_pattern)
        self.nodes.set_add_nodes(self.options.addhost)
        self.nodes.get_nodes(self.options.hostlist)

        if self.options.do_listnodes:
            self.nodes.list_nodes()
            sys.exit(0)

        self.nodes.set_ignore_nodes(self.options.ignore_nodes)
        if len(self.args) < 1:
            self.usage()
            sys.exit(0)

