# Revision 1.1 2007/04/21 19:50:00 iisaka
# initial release

import os, sys
import posix
import string
import re

class Nodes:
    def __init__(self, filename='nodefile'):
	self.nodes = []
	self.ignore_nodelist = []
	self.add_nodelist = []
        self.ignore_pattern = ''
        self.homedir=os.environ['HOME'] + "/.ScatterCmd/" 
        self.searchdir='/usr/local/share/ScatterCmd/'

        if filename == None:
            filename = 'nodefile'

        homenodefile = self.homedir + filename
        sharenodefile = self.searchdir + filename

	if filename[0] == '/' and os.access(filename, os.R_OK):
            self.nodefilepath = filename
        elif os.access(homenodefile, os.R_OK):
            self.nodefilepath = homenodefile
        elif os.access(sharenodefile, os.R_OK):
            self.nodefilepath = sharenodefile
        else:
            self.nodefilepath = ''

    def get_nodefilePath(self):
        return self.nodefilepath

    def get_nodefileList(self,dirpath):
	try:
	    nodesfilelist  = posix.listdir(dirpath)
	except:
	    nodesfilelist  = []
	return nodesfilelist

    def list_nodefile(self):
	print '%s:' % self.homedir
	for nodefile in self.get_nodefileList(self.homedir):
	    print nodefile,
	print
	print '%s:' % self.searchdir
	for nodefile in self.get_nodefileList(self.searchdir):
	    print nodefile,
	print

    def list_nodes(self):
	for node in self.get_nodes():
	    print node

    def set_ignore_nodes(self, aList):
	if aList != None:
            self.ignore_nodelist = string.splitfields(aList, ",")

    def set_ignore_nodes(self, aList):
	if aList != None:
            if len(self.ignore_nodelist) > 0:
                self.ignore_nodelist += string.splitfields(aList, ",")
            else:
                self.ignore_nodelist = string.splitfields(aList, ",")

    def set_ignore_pattern(self, pattern):
	if pattern != None:
            self.ignore_pattern = re.compile(pattern)

    def set_add_nodes(self, aList):
	if aList != None:
            self.add_nodelist = string.splitfields(aList, ",")

    def read_nodefile(self):
        fd = open( self.nodefilepath, "r")
        line = fd.readline()
	self.nodes = []
        while line:
            line = string.splitfields(line, "#")
            if line[0] != "" :
                    self.nodes.append( string.strip( line[0] ))
            line = fd.readline()
        fd.close()

    def get_nodes(self, hostlist=None, uniq=0):
	if hostlist != None:
            self.nodes = string.splitfields(hostlist, ",")
        else:
            self.read_nodefile()
            self.nodes = self.nodes + self.add_nodelist

        for node in self.ignore_nodelist:
            try:
                self.nodes.remove(node)
            except ValueError:
                raise ValueError, "%s not in nodefile" % node 

        if uniq:
            for node in self.nodes:
                if ( self.nodes.count(node) > 1):
                    for i in range(self.nodes.count(node) -1 ):
                        self.nodes.remove(node)

        return self.nodes
